% Attempt to compute Carathéodory-Féjer 
% approximation according to Trefethen&Schmelzer:
% compute poles and residues for the psi_1 function
% on the negative real line.
% Doesn't seem to work so far.
% Last modification Oct 28, 2019.

function [zi,ci,r_inf] = cf_rat_psi1(n)

psi1=@(x)(x./(exp(x)-1));
K=75;    % n of Cheb coeffs
nf=1024;  % n of points for FFT
w=exp(2i*pi*(0:nf-1)/nf);   % roots of unity
t=real(w);
scl=0.0001; %scl=9;
F=zeros(size(t));
g=(t~=-1);
F(g)=psi1(scl*(t(g)-1)./(t(g)+1));  % evaluate
F(1)=1;   % this is psi1(0)
c=real(fft(real(F)))/nf;   % Cheb coeffs of F
f=polyval(c(K+1:-1:1),w);  % analytic part of F
[U,S,V]=svd(hankel(c(2:K+1))); 
s=S(n+1,n+1);
u=U(K:-1:1,n+1)';
v=V(:,n+1)';
zz=zeros(1,nf-K);   % zeros for padding
b=fft([u,zz])./fft([v zz]);   % finite Blaschke product
rt=f-s*w.^K.*b;
rtc=real(fft(rt))/nf;
zr=roots(v);
qj=zr(abs(zr)>1);
qc=poly(qj);
pt=rt.*polyval(qc,w);
ptc=real(fft(pt)/nf);
ptc=ptc(n+1:-1:1);
ci=0*qj;
for k=1:n
    q=qj(k);
    q2=poly(qj(qj~=q));
    ci(k)=polyval(ptc,q)/polyval(q2,q);
end
zi=scl*(qj-1).^2./(qj+1).^2;
ci=4*ci.*zi./(qj.^2-1);
r_inf=0.5*(1+sum(ci./zi));   % 1 = psi1(0)
[m,order]=sort(imag(zi));
zi=zi(order);
ci=ci(order);
