% Implements Thm 18.7 from Yuli's book
% (inversion of a 1,1 qs matrix).
%

function [newp,newa,newq,newg,newb,newh,newd]=invert_187_function(p,a,q,g,b,h,d)

N=length(d);  % matrix size
% Warning: no check on consistency of generator sizes!

% **** Check: ****
% A=recover_matrix(p,q,a,g,h,b,d);
% ****************


% allocate new generators
newp=zeros(N,1);
newq=zeros(N,1);
newa=zeros(N,1);
newg=zeros(N,1);
newh=zeros(N,1);
newb=zeros(N,1);
newd=zeros(N,1);

% allocate auxiliary variables
gamma=zeros(N,1);
f=zeros(N,1);
lambda=zeros(N,1);

% implement formulas
gamma(1)=d(1);
newq(1)=q(1)/gamma(1);
newg(1)=g(1)/gamma(1);
f(1)=newq(1)*gamma(1)*newg(1);
for k=2:N-1
    gamma(k)=d(k)-p(k)*f(k-1)*h(k);
    newq(k)=(q(k)-a(k)*f(k-1)*h(k))/gamma(k);
    newg(k)=(g(k)-p(k)*f(k-1)*b(k))/gamma(k);
    f(k)=a(k)*f(k-1)*b(k)+newq(k)*gamma(k)*newg(k);
end
gamma(N)=d(N)-p(N)*f(N-1)*h(N);

lambda(N)=-h(N)*p(N)/gamma(N);
newh(N)=h(N)/gamma(N);
newp(N)=-p(N)/gamma(N);
newd(N)=1/gamma(N);
for k=N-1:-1:2
    newa(k)=a(k)-newq(k)*p(k);
    newb(k)=b(k)-h(k)*newg(k);
    lambda(k)=-h(k)*p(k)/gamma(k)+newb(k)*lambda(k+1)*newa(k);
    newh(k)=h(k)/gamma(k)+newb(k)*lambda(k+1)*newq(k);
    newp(k)=-p(k)/gamma(k)-newg(k)*lambda(k+1)*newa(k);
    newd(k)=1/gamma(k)-newg(k)*lambda(k+1)*newq(k);
end
newd(1)=1/gamma(1)-newg(1)*lambda(2)*newq(1);

%%%%%%%%%%%%%%%%
% edit needed
% (mistake in formulas?)
newh=-newh;
%%%%%%%%%%%%%%%%

% **** Check: ****
% B=recover_matrix(newp,newq,newa,newg,newh,newb,newd);
% norm(A*B-eye(N))
% ****************