% Function called by compare_rational_complex.m
% Computes mixed approximation of \psi_1(z)
% with degrees (np, m). This version uses scaling.

function [w] = our_rat_eval_ws(np,m,z)

% We assume np>0.

% Scale variable:

s=0;
while max(max(abs(z)))>8 % or another suitable threshold
    z=z/2;
    s=s+1;
end
disp('Mixed approx, scaling with s=')
disp(s)


% Compute approximation:

n=length(z);
w=zeros(n);
xx=bernoulli(0:2*np); 
   
for i=1:n
    for j=1:n
        w(i,j)=1; 
        aa=z(i,j); 
        for jj=2:2*np+1
            w(i,j)=w(i,j)+(xx(jj)/factorial(jj-1))*aa; 
            aa=aa*z(i,j);
        end
        ss=(z(i,j)/(2*pi))^2;
        for k=1:m
            w(i,j)=w(i,j)+(2*(-1)^np*ss^(np+1))/((k*k+ss)*(k^(2*np)));
        end
       
    end
end


% Now the squaring steps:
for k=1:s
    w=2*w.*w./(z+2*w);
    z=2*z;
end

end